﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using CG1.Core.Mathematics;

namespace CG1.Ex2
{
    public partial class Form1 : Form
    {
        Vector4 U = new Vector4();
        Vector4 V = new Vector4();
        Vector4 W = new Vector4();

        Matrix44 A = new Matrix44();
        Matrix44 B = new Matrix44();
        Matrix44 C = new Matrix44();

        public Form1()
        {
            InitializeComponent();
        }

        double Parse(String text)
        {
            double res = 0;
            Double.TryParse(text, out res);
            return res;
        }

        void ReadValues()
        {
            A.M[0, 0] = Parse(tbA11.Text);
            A.M[0, 1] = Parse(tbA12.Text);
            A.M[0, 2] = Parse(tbA13.Text);
            A.M[1, 0] = Parse(tbA21.Text);
            A.M[1, 1] = Parse(tbA22.Text);
            A.M[1, 2] = Parse(tbA23.Text);
            A.M[2, 0] = Parse(tbA31.Text);
            A.M[2, 1] = Parse(tbA32.Text);
            A.M[2, 2] = Parse(tbA33.Text);

            B.M[0, 0] = Parse(tbB11.Text);
            B.M[0, 1] = Parse(tbB12.Text);
            B.M[0, 2] = Parse(tbB13.Text);
            B.M[1, 0] = Parse(tbB21.Text);
            B.M[1, 1] = Parse(tbB22.Text);
            B.M[1, 2] = Parse(tbB23.Text);
            B.M[2, 0] = Parse(tbB31.Text);
            B.M[2, 1] = Parse(tbB32.Text);
            B.M[2, 2] = Parse(tbB33.Text);

            U.X = Parse(tbUX.Text);
            U.Y = Parse(tbUY.Text);
            U.Z = Parse(tbUZ.Text);

            V.X = Parse(tbVX.Text);
            V.Y = Parse(tbVY.Text);
            V.Z = Parse(tbVZ.Text);
        }

        void WriteValues()
        {
            tbWX.Text = W.X.ToString("F2");
            tbWY.Text = W.Y.ToString("F2");
            tbWZ.Text = W.Z.ToString("F2");

            tbC11.Text = C.M[0, 0].ToString("F2");
            tbC12.Text = C.M[0, 1].ToString("F2");
            tbC13.Text = C.M[0, 2].ToString("F2");
            tbC21.Text = C.M[1, 0].ToString("F2");
            tbC22.Text = C.M[1, 1].ToString("F2");
            tbC23.Text = C.M[1, 2].ToString("F2");
            tbC31.Text = C.M[2, 0].ToString("F2");
            tbC32.Text = C.M[2, 1].ToString("F2");
            tbC33.Text = C.M[2, 2].ToString("F2");
        }

        private void cbOp_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void bCalc_Click(object sender, EventArgs e)
        {
            ReadValues();
            switch (cbOp.SelectedItem as String)
            {
                case "W = U + V": W = U + V; break;
                case "W = U - V": W = U - V; break;
                case "W.X = Dot(U,V)": W.X = Vector4.Dot(U, V); break;
                case "W = Cross(U,V)": W = Vector4.Cross3(U, V); break;
                case "W.X = U.Length": W.X = U.Length; break;

                case "C = A + B": C = A + B; break;
                case "C = A - B": C = A - B; break;
                case "C = A * B": C = A * B; break;

                case "W = A * V": W = A * V; break;
                case "W = U * B": W = U * B; break;
            }
            WriteValues();
        }
    }
}
